package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.BmstruckDetailsOrderMapper;
import com.steerinfo.dil.service.IBmstruckDetailsOrderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * BmstruckDetailsOrder服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-10-27 05:06
 * 类描述
 * 修订历史：
 * 日期：2021-10-27
 * 作者：generator
 * 参考：
 * 描述：BmstruckDetailsOrder服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "bmstruckDetailsOrderService")
public class BmstruckDetailsOrderServiceImpl implements IBmstruckDetailsOrderService {

    @Autowired
    private BmstruckDetailsOrderMapper bmstruckDetailsOrderMapper;

    /**
     * 查询采购汽运详单
     * @param detailsId
     * @return
     */
    @Override
    public Map<String, Object> getPurchaseDetailsOrder(Integer detailsId) {
        List<Map<String, Object>> mapList = bmstruckDetailsOrderMapper.getPurchaseDetailsOrder(new BigDecimal(detailsId));
        String amountType = "采购汽运";
        Map<String,Object> mapValue = new HashMap<>();
        String statementNumber = "";
        Date statementTime = (Date) (mapList.get(0).get("detailsTime"));
        BigDecimal detailsAmount = (BigDecimal) (mapList.get(0).get("detailsAmount"));
        Double statementExcludTax = detailsAmount.doubleValue();
        Map<String,Object> statementMap = bmstruckDetailsOrderMapper.getStatementMessage(new BigDecimal(detailsId));
        mapValue.put("startPlace","");
        mapValue.put("endPlace","");
        mapValue.put("statementNumber",statementNumber);
        mapValue.put("statementTime",statementTime);
        mapValue.put("amountType",amountType);
        mapValue.put("statementTotalAmount",statementExcludTax);
        mapValue.put("mapList",mapList);
        mapValue.putAll(statementMap);
        return mapValue;
    }

    /**
     * 查询销售汽运详单
     * @param statementId
     * @return
     */
    @Override
    public List<Map<String, Object>> getSaleDetailsOrder(Integer statementId) {
        List<Map<String, Object>> mapList = bmstruckDetailsOrderMapper.getSaleDetailsOrder(new BigDecimal(statementId));
        return mapList;
    }
}
